﻿Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition
Imports System.Collections.ObjectModel
Public Class CustomEditInteractiveOverlay
   Inherits EditInteractiveOverlay
   Private moEditableLayer As FeatureLayer
   Private mbEditingFeature As Boolean = False
   Private moEditFeature As Feature
   Public Property Map As WinformsMap
   Public Property EditableLayer As FeatureLayer
      Get
         Return moEditableLayer
      End Get
      Set(ByVal value As FeatureLayer)
         moEditableLayer = value
      End Set
   End Property
   Protected Overrides Function MouseUpCore(ByVal interactionArguments As ThinkGeo.MapSuite.DesktopEdition.InteractionArguments) As ThinkGeo.MapSuite.DesktopEdition.InteractiveResult
      Dim oInteractiveResult As InteractiveResult

      Me.ExistingControlPointsLayer.Open()
      UpdateEditLayer()




      oInteractiveResult = MyBase.MouseUpCore(interactionArguments)



      Return oInteractiveResult
   End Function
   Private Sub UpdateEditLayer()

      If mbEditingFeature Then
         '***** Get the layer we are editing
         moEditableLayer.Open()
         With moEditableLayer

            '***** Now get the feature
            If Not .EditTools.IsInTransaction Then
               .EditTools.BeginTransaction()
            End If
            .EditTools.IsTransactionLive = True
            moEditFeature.ColumnValues.Remove("OBJECTID")
            .EditTools.Update(moEditFeature)
            .EditTools.CommitTransaction()
            .Close()
            mbEditingFeature = False
            Map.Refresh()
         End With
      End If
   End Sub
   Protected Overrides Sub OnVertexMoved(ByVal e As ThinkGeo.MapSuite.DesktopEdition.VertexMovedEditInteractiveOverlayEventArgs)
      moEditFeature = e.AffectedVertexFeature
      mbEditingFeature = True
      MyBase.OnVertexMoved(e)
   End Sub
   Protected Overrides Function CalculateVertexControlPointsCore(ByVal feature As ThinkGeo.MapSuite.Core.Feature) As System.Collections.Generic.IEnumerable(Of ThinkGeo.MapSuite.Core.Feature)
      Dim oFeatures As IEnumerable(Of Feature)

      oFeatures = MyBase.CalculateVertexControlPointsCore(feature)

      Return oFeatures
   End Function
End Class
