﻿Imports System.Drawing
Imports System.Collections.ObjectModel
Imports System.Drawing.Printing
Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.DesktopEdition
Imports Infragistics.Win.UltraWinToolbars
Imports Infragistics.Win.UltraWinTree
Imports System.Reflection
Imports AppConfig
Imports MailBee.ImapMail
Imports Infragistics.Shared
Imports Infragistics.Win
Imports Infragistics.Win.UltraWinDock


Public Class MainForm
   Private mbEditingFeature As Boolean = False
   Private moNewPoly As MultipolygonShape
   Private moEditableLayer As FeatureLayer
   Private msLambertMontana As String = "+proj=lcc +lat_1=45 +lat_2=49 +lat_0=44.25 +lon_0=-109.5 +x_0=600000 +y_0=0 +ellps=GRS80 +datum=NAD83 +to_meter=0.3048006096012192 +no_defs"
   Private msConnectionString As String = "Data Source=STEVEM6500\WILDBIRD;Initial Catalog=FieldIFMS;Integrated Security=True;User ID=;Password="
   Private WithEvents moTsb As ToolStripButton


   Public Sub New()

      ' This call is required by the designer.
      InitializeComponent()

      ' Add any initialization after the InitializeComponent() call.
      AppConfig.AppConfig.Initialize("Settings.config")
      AppConfig.AppConfig.SetOption("DEFAULT", "StartupPos", "1000")
      AppConfig.AppConfig.Store()




   End Sub

   Private Sub MainForm_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

      WinformsMap1.EditOverlay = New CustomEditInteractiveOverlay
      CType(WinformsMap1.EditOverlay, CustomEditInteractiveOverlay).Map = WinformsMap1
      With WinformsMap1.EditOverlay
         .EditShapesLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.SimpleColors.Blue, 1)
         .EditShapesLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
         .CanAddVertex = True
         .CanDrag = False
         .CanRotate = False
         .CanRemoveVertex = True
         .CanReshape = True
         .CanResize = False
      End With

      WinformsMap1.TrackOverlay.TrackMode = TrackMode.None


      Dim oTsb As ToolStripButton

      For Each o As ToolStripItem In ToolStrip1.Items
         If TypeOf o Is ToolStripButton Then
            AddHandler CType(o, ToolStripButton).CheckedChanged, AddressOf Me.moTsb_CheckedChanged
         End If
      Next o


      LoadData()


   End Sub

   Private Sub LoadData()
      Dim oRasterLayer As MrSidRasterLayer
      Dim oShapeFile As ShapeFileFeatureLayer

      Dim oOverlay As New LayerOverlay


      oShapeFile = New ShapeFileFeatureLayer("..\..\Data\NAD83_17_TestLayer.shp", ShapeFileReadWriteMode.ReadWrite)
      ShapeFileFeatureLayer.BuildIndexFile("..\..\Data\NAD83_17_TestLayer.shp", BuildIndexMode.DoNotRebuild)
      With oShapeFile
         .ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.SimpleColors.Blue, 1)
         .ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
      End With

      CType(WinformsMap1.EditOverlay, CustomEditInteractiveOverlay).EditableLayer = oShapeFile
      moEditableLayer = oShapeFile


      WinformsMap1.Overlays.Add("StaticOverlay", oOverlay)
      oOverlay.Layers.Add("ShapeFile", oShapeFile)

      Dim oProj4 As New ManagedProj4Projection(ManagedProj4Projection.GetEsriParameters(26917), ManagedProj4Projection.GetEsriParameters(4326))
      WinformsMap1.MapUnit = GeographyUnit.DecimalDegree
      With oShapeFile
         .FeatureSource.Projection = oProj4
         .Open()
         WinformsMap1.CurrentExtent = .GetBoundingBox
         .Close()
      End With
      WinformsMap1.Refresh()

   End Sub
   Private Sub ConvertToCustomCS()
      Dim str1 As String = ManagedProj4Projection.GetEpsgParameters(4326)
      Dim str2 As String = "+proj=lcc +lat_1=45 +lat_2=49 +lat_0=44.25 +lon_0=-109.5 +x_0=600000 +y_0=0 +ellps=GRS80 +datum=NAD83 +to_meter=0.3048006096012192 +no_defs"
      Dim sourceShapeFile As String = "..\..\Data\Austinstreets.shp"
      Dim targetSourceShapeFile As String = "..\..\Data\Projected_Austinstreets.shp"

      Dim proj4 As ManagedProj4Projection = New ManagedProj4Projection(str1, str2)
      ShapeFileFeatureLayer.SaveToProjection(sourceShapeFile, targetSourceShapeFile, proj4, OverwriteMode.Overwrite)

   End Sub

   Public Sub AddNewPoly(ByVal oShape As BaseShape)
      '***** Now get the shape to split
      AddDrawingToShape(oShape)
      If MessageBox.Show("Are you finished drawing the polygon?", "Done?", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = vbYes Then
         '***** Done drawing the polygon
         '***** Get the layer we are editing

         'oShapeLayer = CType(WinformsMap1.FindFeatureLayer("StatesShp"), ShapeFileFeatureLayer)
         'With moEditableLayer
         '   .Open()
         '   If Not .EditTools.IsInTransaction Then
         '      .EditTools.BeginTransaction()
         '   End If
         '   .EditTools.IsTransactionLive = True
         '   Dim oValidation As ShapeValidationResult = moNewPoly.Validate(ShapeValidationMode.Advanced)

         '   '.EditTools.Add(moNewPoly)
         '   .EditTools.Add(CustomSimplify(moNewPoly, GeographyUnit.Meter, 10, DistanceUnit.Feet, SimplificationType.DouglasPeucker))
         '   .EditTools.CommitTransaction()
         '   WinformsMap1.TrackOverlay.TrackShapeLayer.InternalFeatures.Clear()
         '   WinformsMap1.Refresh()
         '   moNewPoly = Nothing
         'End With

      End If
   End Sub
   Private Sub AddDrawingToShape(ByVal oShape As BaseShape)
      Dim oPoly As PolygonShape
      If moNewPoly Is Nothing Then
         '***** No drawings have been added yet, so this will start out being the main poly
         moNewPoly = New MultipolygonShape()
         moNewPoly.Polygons.Add(CType(oShape, PolygonShape))
      Else
         '***** At least one polygon has already been added, so we need to 
         '***** determine if a new polygon needs to be created or if the
         '***** polygon that was just drawn should be added as as inner ring 
         '***** to the existing polygon
         For Each oPoly In moNewPoly.Polygons
            If oPoly.Contains(oShape) Then
               oPoly.InnerRings.Add(CType(oShape, PolygonShape).OuterRing)
               Return
            End If
         Next oPoly
         '***** We got down to here without adding the shape so we need to make a new polygon
         moNewPoly.Polygons.Add(CType(oShape, PolygonShape))
      End If
   End Sub
   Private Function CustomSimplify(ByVal targetShape As AreaBaseShape, ByVal targetShapeUnit As GeographyUnit, ByVal tolerance As Double, ByVal toleranceUnit As DistanceUnit, ByVal simplificationType As SimplificationType) As MultipolygonShape

      If targetShapeUnit = GeographyUnit.DecimalDegree Then

         Dim boundingBox As RectangleShape = targetShape.GetBoundingBox()
         Dim latitude As Double = boundingBox.GetCenterPoint().Y
         Dim longitudeDifference As Double = DecimalDegreesHelper.GetLongitudeDifferenceFromDistance(tolerance, toleranceUnit, latitude)
         ' We set GeographyUnit and DistanceUnit both to meter here just because we want to set the same Unit, this is a workaround.
         Return PolygonShape.Simplify(targetShape, GeographyUnit.Meter, longitudeDifference, DistanceUnit.Meter, simplificationType)
      Else
         Return PolygonShape.Simplify(targetShape, targetShapeUnit, tolerance, toleranceUnit, simplificationType)
      End If
   End Function
   Private Function GetProj4ForStates() As ManagedProj4Projection

      Dim str1 As String = ManagedProj4Projection.GetEpsgParameters(4267)
      Dim str2 As String = ManagedProj4Projection.GetEpsgParameters(26916)
      Dim proj4 As ManagedProj4Projection = New ManagedProj4Projection(str1, str2)

      Return proj4

   End Function
   Private Function GetProj4ForMontana() As ManagedProj4Projection

      Dim str1 As String = msLambertMontana
      Dim str2 As String = ManagedProj4Projection.GetEpsgParameters(26916)
      Dim proj4 As ManagedProj4Projection = New ManagedProj4Projection(str1, str2)

      Return proj4

   End Function

   Private Sub WinformsMap1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles WinformsMap1.MouseDown
      Dim oPoint As New PointShape
      Dim sKey As String = String.Empty

      sKey = MapToolsKey()
      oPoint = ExtentHelper.ToWorldCoordinate(WinformsMap1.CurrentExtent, New ScreenPointF(e.X, e.Y), WinformsMap1.Width, WinformsMap1.Height)
      Select Case sKey
         Case "tsbSelect"
            AddShapeForEditing(oPoint)
         Case "tsbNodes"
            'don't do anything right now
      End Select

   End Sub
   Private Sub AddShapeForEditing(ByVal oPoint As PointShape)
      Dim oFeatures As Collection(Of Feature)
      moEditableLayer.Open()
      oFeatures = moEditableLayer.QueryTools.GetFeaturesContaining(oPoint, ReturningColumnsType.AllColumns)
      oFeatures = moEditableLayer.QueryTools.GetFeaturesContaining(oPoint, ReturningColumnsType.NoColumns)
      With WinformsMap1.EditOverlay
         .EditShapesLayer.Open()
         .EditShapesLayer.EditTools.BeginTransaction()
         .EditShapesLayer.InternalFeatures.Clear()
         If oFeatures.Count > 0 Then
            .EditShapesLayer.EditTools.Add(oFeatures(0))
         End If
         Dim result As TransactionResult = .EditShapesLayer.EditTools.CommitTransaction()
         .EditShapesLayer.BuildIndex()
         '.EditShapesLayer.EditTools.CommitTransaction()
         .EditShapesLayer.Close()
         .CalculateAllControlPoints()
         .ExistingControlPointsLayer.ZoomLevelSet.ZoomLevel01.CustomStyles.Clear()
         .ExistingControlPointsLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.CreateSimpleCircleStyle(GeoColor.SimpleColors.Black, 8)
      End With

      WinformsMap1.Refresh(WinformsMap1.EditOverlay)

   End Sub

   Private Function MapToolsKey() As String
      Dim oTsi As ToolStripItem
      Dim sKey As String = String.Empty

      'For Each oTool In Me.UltraToolbarsManager1.Tools
      '   If TypeOf oTool Is StateButtonTool Then
      '      oStateButton = CType(oTool, StateButtonTool)
      '      If oStateButton.OptionSet.Key = "MapTools" Then
      '         If oStateButton.Checked Then
      '            sKey = oStateButton.Key
      '            Exit For
      '         End If
      '      End If
      '   End If
      'Next oTool

      For Each oTsi In Me.ToolStrip1.Items
         If TypeOf oTsi Is ToolStripButton Then
            If CType(oTsi, ToolStripButton).CheckState = CheckState.Checked Then
               sKey = oTsi.Name
               Exit For
            End If
         End If

      Next oTsi

      Return sKey
   End Function

   ' Displays the custom attributes applied to the specified member.
   Sub DisplayAttributes(ByVal indent As Int32, ByVal mi As MemberInfo)
      ' Get the set of custom attributes; if none exist, just return.
      Dim attrs() As Object = mi.GetCustomAttributes(False)
      If attrs.Length = 0 Then Return

      ' Display the custom attributes applied to this member.
      Display(indent + 1, "Attributes:")
      Dim o As Object
      For Each o In attrs
         Display(indent + 2, "{0}", o.ToString())
      Next
   End Sub

   ' Display a formatted string indented by the specified amount.
   Sub Display(ByVal indent As Int32, ByVal format As String, ByVal ParamArray params() As Object)
      Debug.WriteLine(String.Format(New String(" "c, indent * 2)))
      Debug.WriteLine(String.Format(format, params))
   End Sub


   Private Sub tsbPan_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbPan.Click

   End Sub

   Private Sub moTsb_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs)
      Dim oTsb As ToolStripButton = CType(sender, ToolStripButton)

      If oTsb.Checked = True Then
         For Each o As ToolStripItem In ToolStrip1.Items
            If o.Name <> oTsb.Name Then
               If TypeOf o Is ToolStripButton Then
                  CType(o, ToolStripButton).Checked = False
               End If
            End If
         Next o
      End If

   End Sub

End Class
